<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_IMAGEOBJECT_INCLUDED') ) {
	define ('_OPN_CLASS_IMAGEOBJECT_INCLUDED', 1);

	define ('_MIRROR_FLOP', 0);
	define ('_MIRROR_FLIP', 1);
	define ('_MIRROR_FLIPFLOP', 2);

	/**
	* Provides an interface for generating imageobject:: objects of various
	* types
	*
	* @param $directory
	* @param $filename
	* @return object
	*/

	function &loadDriverImageObject ($directory, $filename) {

		global $opnConfig;
		switch ($opnConfig['mediagallery_libtype']) {
			case 0:
				$driver = 'gd';
				break;
			case 1:
				$driver = 'im';
				break;
			case 2:
				$driver = 'imext';
				break;
			case 3:
				$driver = 'imperl';
				break;
		}
		// end switch
		$driver = strtolower ($driver);
		@include_once (_OPN_ROOT_PATH . 'modules/mediagallery/include/class.imageobject_' . $driver . '.php');
		$class = 'imageobject_' . $driver;
		if (class_exists ($class) ) {
			$c =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ $class ($directory, $filename);
			return $c;
		}
		opnErrorHandler (E_ERROR, 'Unable to find class for driver imageobject_' . $driver, __FILE__, __LINE__);
		$object = null;
		return (object) $object;

	}
	// end function

	class imageobject {

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_imgRes;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_height = 0;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_width = 0;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_string = '';

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_message = '';

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_directory = '';

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_filename = '';

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_quality = 100;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_truecolor = false;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_fullname = '';

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_escapedname = '';

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_filesize = 0;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_prop_resize = 1;
		/**
		 * Class constructor
		 * 		
		 * @param $directory
		 * @param $filename
		 */
		function /*<{4php5}>imageobject!!__construct<{4php5/}>*//*<{delete}>*/imageobject/*<{delete/}>*/ ($directory, $filename) {

			$this->SetParams ($directory, $filename);
		}

		/**
		 * Set the params
		 * 		
		 * @param $directory
		 * @param $filename
		 */
		function SetParams ($directory, $filename) {

			global $opnConfig;

			$this->_prop_resize = $opnConfig['mediagallery_proportionally_resize'];
			$this->_fullname = $directory . $filename;
			$this->_escapedname = escapeshellarg ($directory . $filename);
			$this->_directory = $directory;
			$this->_filename = $filename;
		}

		/**
		* Returns the height of the image
		*
		* @return int
		*/

		function GetHeight () {
			return $this->_height;

		}

		/**
		* Returns the width of the image
		*
		* @return int
		*/

		function GetWidth () {
			return $this->_width;

		}

		/**
		* Returns the sizestring of the image
		*
		* @return string
		*/

		function GetSizeString () {
			return $this->_string;

		}

		/**
		* Returns the errormessages
		*
		* @return string
		*/

		function GetErrorMessages () {
			return $this->_message;

		}

		/**
		 * Return true if the errormessage is set
		 * 		
		 * @return boolean
		 */
		function IsError () {

			if ($this->_message != '') {
				return true;
			}
			return false;
		}

		/**
		* Returns the filename
		*
		* @return string
		*/

		function GetFilename () {
			return $this->_filename;

		}

		/**
		* Returns the fullename (directory and filename)
		*
		* @return string
		*/

		function GetFullname () {
			return $this->_fullname;

		}

		/**
		* Returns the directory
		*
		* @return string
		*/

		function GetDirectory () {
			return $this->_directory;

		}

		/**
		* Sets the quality for the JPG images
		*
		* @param $quality
		*/

		function SetQuality ($quality) {

			$this->_quality = $quality;

		}

		/**
		* Clears the errormessage
		*
		*/

		function CleanErrorMessage () {

			$this->_message = '';

		}

		/**
		 * Set's the needed params
		 * 
		 * @param string $directory
		 * @param string $filename
		 */
		function PerformParams ($directory, $filename) {

			$t = $directory;
			$t = $filename;
			opnErrorHandler (E_WARNING, 'Direct call of an abstract method', __FILE__, __LINE__);
		}

		/**
		* Crop an image
		* Abstract method. Must be defined in the childclass
		*
		* @param $clipval
		*/

		function cropImage (&$clipval) {

			$t = $clipval;
			opnErrorHandler (E_WARNING, 'Direct call of an abstract method', __FILE__, __LINE__);

		}

		/**
		* Resize an image
		* Abstract method. Must be defined in the childclass
		*
		* @param int	$new_w	new width
		* @param int	$new_h	new height
		*/

		function resizeImage ($new_w = 0, $new_h = 0) {

			$t = $new_h;
			$t = $new_w;
			opnErrorHandler (E_WARNING, 'Direct call of an abstract method', __FILE__, __LINE__);

		}

		/**
		* Rotate an image
		* Abstract method. Must be defined in the childclass
		*
		* @param $angle
		*/

		function rotateImage (&$angle) {

			$t = $angle;
			opnErrorHandler (E_WARNING, 'Direct call of an abstract method', __FILE__, __LINE__);

		}

		/**
		 * Mirror an image horizontal, vertical or both
		 * 		
		 * @param $type
		 */
		function mirrorImage ($type) {

			$t = $type;
			opnErrorHandler (E_WARNING, 'Direct call of an abstract method', __FILE__, __LINE__);
		}

		/**
		* Get the imageinfo array
		* Abstract method. Must be defined in the childclass
		*
		* @param $filename
		* @return mixed bool or array
		*/

		function GetImageInfo ($filename) {

			$t = $filename;
			opnErrorHandler (E_WARNING, 'Direct call of an abstract method', __FILE__, __LINE__);
			return false;

		}

		/**
		* Creates a thumbnail for the image
		* Abstract method. Must be defined in the childclass
		*
		* @param $filename
		* @param $thumbname
		* @param $width
		* @param $height
		* @return bool
		*/
		function CreateThumbnail ($filename, $thumbname, $width, $height) {

			$t = $filename;
			$t = $thumbname;
			$t = $width;
			$t = $height;
			opnErrorHandler (E_WARNING, 'Direct call of an abstract method', __FILE__, __LINE__);
			return true;

		}

		/**
		* Converts an image to a JPG image.
		* Abstract method. Must be defined in the childclass
		*
		* @param $filename
		* @param $convertname
		* @return bool
		*/

		function ConvertImage ($filename, $convertname) {

			$t = $filename;
			$t = $convertname;
			opnErrorHandler (E_WARNING, 'Direct call of an abstract method', __FILE__, __LINE__);
			return true;

		}

		/**
		 * Size an image
		 * 		
		 * @param $width
		 * @param $height
		 * @return boolean
		 */
		function SizeImage ($width, $height) {

			$t = $width;
			$t = $height;
			opnErrorHandler (E_WARNING, 'Direct call of an abstract method', __FILE__, __LINE__);
			return false;

		}
		// private functions

		/**
		 * Builds the filename for the convert of animated images into non animated images
		 * 		
		 * @param $filename
		 * @param $scene
		 * @return string
		 */
		function _get_scene_filename ($filename, $scene) {

			$dir = dirname ($filename) . '/';
			$ext = basename ($filename);
			$ext = explode ('.', $ext);
			$ext[0] .= '-' . $scene;
			$file = implode ('.', $ext);
			$file = $dir . $file;
			return $file;
		}

	}
}

?>