<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_CLASS_IMAGEOBJECT_IMPERL_INCLUDED') ) {
	define ('_OPN_CLASS_IMAGEOBJECT_IMPERL_INCLUDED', 1);

	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_http.php');
	class imageobject_imperl extends imageobject {

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_http;

		/**
		 * Class constructor
		 * 
		 * @param $directory
		 * @param $filename
		 */
		function /*<{4php5}>imageobject_im!!__construct<{4php5/}>*//*<{delete}>*/imageobject_imperl/*<{delete/}>*/ ($directory, $filename) {

			$this->PerformParams ($directory, $filename);

		}

		/**
		 * Set's the needed params
		 * 
		 * @param string $directory
		 * @param string $filename
		 */
		function PerformParams ($directory, $filename) {

			$this->SetParams ($directory, $filename);
			$this->_truecolor = true;
			$this->_http = /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ http ();
			if (file_exists ($directory . $filename) ) {
				$this->_filesize = round (filesize ($this->_fullname)/1000);
				if ($this->_filesize>0) {
					$size = $this->GetImageInfo ($this->_fullname);
					if ($size) {
						$this->_imgRes = true;
					}
					$this->_width = $size[0];
					$this->_height = $size[1];
					$this->_string = $size[3];
				}
			}
			// if

		}

		/**
		* Crop an image
		*
		* @param $clipval
		*/

		function cropImage (&$clipval) {

			global $opnConfig;

			$cliparray = split (",", $clipval);
			$clip_top = $cliparray[0];
			$clip_right = $cliparray[1];
			$clip_bottom = $cliparray[2];
			$clip_left = $cliparray[3];
			$new_w = $clip_right- $clip_left;
			$new_h = $clip_bottom- $clip_top;
			$imgFile = $this->_escapedname;
			$imaction = urlencode('-crop \'' . $new_w . 'x' . $new_h . ' +' . $clip_left . ' +' . $clip_top . '\'');
			$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/mogrify.pl?action=convert&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'].'&quality=' . $this->_quality.'&imoptions='.$opnConfig['mediagallery_imoptions'].'&imaction='.$imaction . '&srcfile='.$imgFile;
			$ret = $this->_query_perl ($parm);
			if (substr_count ($ret, ':') > 0) {
				$this->_setError ($ret);
				return false;
			}
			// Call the constructor again to repopulate the dimensions etc
			$this->PerformParams ($this->_directory, $this->_filename);

		}

		/**
		* Resize an image
		*
		* @param int	$new_w	new width
		* @param int	$new_h	new height
		*/

		function resizeImage ($new_w = 0, $new_h = 0) {

			global $opnConfig;

			$imgFile = $this->_escapedname;
			$imaction = urlencode ('-geometry \'' . $new_w . 'x' . $new_h . '\'');
			$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/mogrify.pl?action=convert&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'].'&quality=' . $this->_quality.'&imoptions='.$opnConfig['mediagallery_imoptions'].'&imaction='.$imaction . '&srcfile='.$imgFile;
			$ret = $this->_query_perl ($parm);
			if (substr_count ($ret, ':') > 0) {
				$this->_setError ($ret);
				return false;
			}
			// Call the constructor again to repopulate the dimensions etc
			$this->PerformParams ($this->_directory, $this->_filename);

		}

		/**
		* Rotate an image
		*
		* @param $angle
		*/

		function rotateImage (&$angle) {

			global $opnConfig;

			$imgFile = $this->_escapedname;
			$imaction = urlencode ('-rotate \'' . $angle . '\'');
			$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/mogrify.pl?action=convert&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'].'&quality=' . $this->_quality.'&imoptions='.$opnConfig['mediagallery_imoptions'].'&imaction='.$imaction . '&srcfile='.$imgFile;
			$ret = $this->_query_perl ($parm);
			if (substr_count ($ret, ':') > 0) {
				$this->_setError ($ret);
				return false;
			}
			// Call the constructor again to repopulate the dimensions etc
			$this->PerformParams ($this->_directory, $this->_filename);

		}

		/**
		 * Mirror an image horizontal, vertical or both
		 * 		
		 * @param $type
		 */
		function mirrorImage ($type) {

			global $opnConfig;

			$imgFile = $this->_escapedname;
			switch ($type) {
				case _MIRROR_FLOP:
					$imaction = urlencode ('-flop ');
					break;
				case _MIRROR_FLIP:
					$imaction = urlencode ('-flip ');
					break;
				case _MIRROR_FLIPFLOP:
					$imaction = urlencode ('-flip -flop ');
					break;
			} /* switch */
			$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/mogrify.pl?action=convert&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'].'&quality=' . $this->_quality.'&imoptions='.$opnConfig['mediagallery_imoptions'].'&imaction='.$imaction . '&srcfile='.$imgFile;
			$ret = $this->_query_perl ($parm);
			if (substr_count ($ret, ':') > 0) {
				$this->_setError ($ret);
				return false;
			}
			// Call the constructor again to repopulate the dimensions etc
			$this->PerformParams ($this->_directory, $this->_filename);

		}

		/**
		* Get the imageinfo array
		*
		* @param $filename
		* @return mixed bool or array
		*/

		function GetImageInfo ($filename) {

			global $opnConfig;

			$filename = escapeshellarg ($filename);
			if ($this->_get_scenes ($filename) > 1) {
				$imginfo = $this->_get_animated_dimension ($filename);
			} else {
				$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/identify.pl?action=identify&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'] . '&file='.$filename . '&format=%wx%h';
				$ret = $this->_query_perl ($parm);
				if (substr_count ($ret, ':') > 0) {
					$this->_setError ($ret);
					return false;
				}
				$imginfo = explode ('x', $ret);
				$imginfo[3] = 'height="' . $imginfo[1] . '" width="' . $imginfo[0] . '"';
				$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/identify.pl?action=identify&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'] . '&file='.$filename . '&format=%m';
				$ret = $this->_query_perl ($parm);
				if (substr_count ($ret, ':') > 0) {
					$this->_setError ($ret);
					return false;
				}
				if ($ret == 'JPEG') {
					$imginfo[2] = IMAGETYPE_JPEG;
				} else {
					$imginfo[2] = $ret;
				}
				if ($ret == 'SVG') {
					$imginfo[0] += 1;
					$imginfo[1] += 1;
				}
			}
			return $imginfo;

		}

		/**
		* Creates a thumbnail for the image
		*
		* @param $filename
		* @param $thumbname
		* @param $width
		* @param $height
		* @param $docheck
		* @return bool
		*/
		function CreateThumbnail ($filename, $thumbname, $width, $height, $docheck = false) {

			global $opnConfig;

			$imgFile = escapeshellarg ($filename);
			$thumbFile = escapeshellarg ($thumbname);
			$prop = '';
			if (!$this->_prop_resize) {
				$prop = '!';
			} else {
				if ($docheck) {
					$imginfo = $this->GetImageInfo ($filename);
					$w = $imginfo[0];
					$h = $imginfo[1];
					$ratioh = $h / $w;
					$ratiow = $w / $h;
					if ($w < $h) {
						$height = ceil ($width * $ratioh);
					} elseif ($h < $w) {
						$width = ceil ($height * $ratiow);
					}
				}
			}
			$commando = $width . 'x' . $height;
			$prop .= '>';
			$imaction = urlencode ('-resize \'' . $commando . $prop . '\'');
			$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/convert.pl?action=convert&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'].'&quality=' . $this->_quality.'&imoptions='.$opnConfig['mediagallery_imoptions'].'&imaction='.$imaction . '&srcfile='.$imgFile.'&dstfile='.$thumbFile;
			$ret = $this->_query_perl ($parm);
			if (substr_count ($ret, ':') > 0) {
				$this->_setError ($ret);
				return false;
			}
			$scenes = $this->_get_scenes ($imgFile);
			if ($scenes > 1) {
				$file =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile ();
				if (file_exists ($thumbname)) {
					$file->delete_File ($thumbname);
				}
				$scene0 = $this->_get_scene_filename ($thumbname, 0);
				$file->rename_file($scene0, $thumbname, '0666');
				for ($i = 1; $i < $scenes; $i++) {
					$scene = $this->_get_scene_filename ($thumbname, $i);
					$file->delete_File ($scene);
				}
				unset($file);
			}
			return true;

		}

		/**
		* Converts an image to a another format (normaly JPG).
		*
		* @param $filename
		* @param $convertname
		* @return bool
		*/

		function ConvertImage ($filename, $convertname) {

			global $opnConfig;

			$imgFile = escapeshellarg ($filename);
			$convertFile = escapeshellarg ($convertname);
			$imaction = '';
			$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/convert.pl?action=convert&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'].'&quality=' . $this->_quality.'&imoptions='.$opnConfig['mediagallery_imoptions'].'&imaction='.$imaction . '&srcfile='.$imgFile.'&dstfile='.$convertFile;
			$ret = $this->_query_perl ($parm);
			if (substr_count ($ret, ':') > 0) {
				$this->_setError ($ret);
				return false;
			}
			return true;

		}

		/**
		 * Size an image
		 * 		
		 * @param $width
		 * @param $height
		 * @return boolean
		 */
		function SizeImage ($width, $height) {


			global $opnConfig;

			$imgFile = $this->_escapedname;
			$imaction = urlencode ('-geometry \'' . $width . 'x' . $height . '\'');
			$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/mogrify.pl?action=convert&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'].'&quality=' . $this->_quality.'&imoptions='.$opnConfig['mediagallery_imoptions'].'&imaction='.$imaction . '&srcfile='.$imgFile;
			$ret = $this->_query_perl ($parm);
			if (substr_count ($ret, ':') > 0) {
				$this->_setError ($ret);
				return false;
			}
			return true;
		}

		// private functions

		function _setError ($line) {

			$this->_message .= $line . '<br />';

		}

		function _query_perl ($parm) {

			$ret = '';
			$status = $this->_http->get ($parm);
			if ($status == HTTP_STATUS_OK) {
				$ret = $this->_http->get_response_body ();
				$ret = substr ($ret, 0, -1);
			} else {
				$ret = 'received status: ' . $status;
				$ret .= 'url: '.$parm;
			}
			$this->_http->disconnect ();
			return $ret;
		}

		/**
		 * Returns the Scenenumbers of a mediafile
		 * 		
		 * @param $imgFile
		 * @return mixed int or boolean
		 */
		function _get_scenes ($filename) {

			global $opnConfig;

			$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/identify.pl?action=identify&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'] . '&file='.$filename . '&format=%n';
			$ret = $this->_query_perl ($parm);
			if (substr_count ($ret, ':') > 0) {
				$this->_setError ($ret);
				return false;
			}
			return $ret;
		}

		/**
		 * Returns the max. width and height for a mediafile with more than one image
		 * 		
		 * @param $filename
		 * @return mixed boolean or array
		 */
		function _get_animated_dimension ($filename) {

			global $opnConfig;

			$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/identify.pl?action=identify&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'] . '&file='.$filename . '&format=%wx%h%%';
			$ret = $this->_query_perl ($parm);
			if (substr_count ($ret, ':') > 0) {
				$this->_setError ($ret);
				return false;
			}
			$vals = explode ('%', $ret);
			unset($vals[count ($vals) - 1]);
			$imginfo = array ();
			$imginfo[0] = 0;
			$imginfo[1] = 0;
			foreach ($vals as $val) {
				$img = explode ('x', $val);
				$imginfo[0] = max ($imginfo[0], $img[0]);
				$imginfo[1] = max ($imginfo[1], $img[1]);
			}
			$imginfo[3] = 'height="' . $imginfo[1] . '" width="' . $imginfo[0] . '"';
			$parm = $opnConfig['opn_url_cgi'] . '/cgi-bin/identify.pl?action=identify&opnpath=' . $opnConfig['root_path_base']. '&impath=' . $opnConfig['mediagallery_impath'] . '&file='.$filename . '&format=%m%%';
			$ret = $this->_query_perl ($parm);
			if (substr_count ($ret, ':') > 0) {
				$this->_setError ($ret);
				return false;
			}
			$vals = explode ('%', $ret);
			if ($vals[0] == 'JPEG') {
				$imginfo[2] = IMAGETYPE_JPEG;
			} else {
				$imginfo[2] = $vals[0];
			}
			unset($vals);
			return $imginfo;
		}

	}
}

?>