<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_INCLUDE_EXIF_FUJI_INCLUDED') ) {
	define ('_OPN_INCLUDE_EXIF_FUJI_INCLUDED', 1);
	//=================
	// Looks up the name of the tag for the MakerNote (Depends on Manufacturer)
	//====================================================================
	function lookup_Fujifilm_tag($tag) {

		switch($tag) {
			case '0000':
				$tag = 'Version';
				break;
			case '1000':
				$tag = 'Quality';
				break;
			case '1001':
				$tag = 'Sharpness';
				break;
			case '1002':
				$tag = 'WhiteBalance';
				break;
			case '1003':
				$tag = 'Color';
				break;
			case '1004':
				$tag = 'Tone';
				break;
			case '1010':
				$tag = 'FlashMode';
				break;
			case '1011':
				$tag = 'FlashStrength';
				break;
			case '1020':
				$tag = 'Macro';
				break;
			case '1021':
				$tag = 'FocusMode';
				break;
			case '1030':
				$tag = 'SlowSync';
				break;
			case '1031':
				$tag = 'PictureMode';
				break;
			case '1032':
				$tag = 'Unknown';
				break;
			case '1100':
				$tag = 'ContinuousTakingBracket';
				break;
			case '1200':
				$tag = 'Unknown';
				break;
			case '1300':
				$tag = 'BlurWarning';
				break;
			case '1301':
				$tag = 'FocusWarning';
				break;
			case '1302':
				$tag = 'AEWarning';
				break;
			default:
				$tag = 'unknown:'.$tag;
				break;
		}

		return $tag;
	}

	//=================
	// Formats Data for the data type
	//====================================================================
	function formatFujifilmData($type,$tag,$intel,$data) {

		if ($type=='ASCII') {


		} elseif ($type=='URATIONAL' || $type=='SRATIONAL') {
			$data = bin2hex($data);
			if ($intel==1) {
				$data = intel2Moto($data);
			}
			$top = hexdec(substr($data,8,8));
			$bottom = hexdec(substr($data,0,8));
			if ($bottom!=0) {
				$data=$top/$bottom;
			} elseif ($top==0) {
				$data = 0;
			} else {
				$data=$top.'/'.$bottom;
			}
			if ($tag=='1011') { //FlashStrength
				$data=$data.' EV';
			}

		} elseif ($type=='USHORT' || $type=='SSHORT' || $type=='ULONG' || $type=='SLONG' || $type=='FLOAT' || $type=='DOUBLE') {
			$data = bin2hex($data);
			if ($intel==1) {
				$data = intel2Moto($data);
			}
			$data=hexdec($data);

			if ($tag=='1001') { //Sharpness
				if ($data == 1) {
					$data = 'Soft';
				} elseif ($data == 2) {
					$data = 'Soft';
				} elseif ($data == 3) {
					$data = 'Normal';
				} elseif ($data == 4) {
					$data = 'Hard';
				} elseif ($data == 5) {
					$data = 'Hard';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1002') { //WhiteBalance
				if ($data == 0) {
					$data = 'Auto';
				} elseif ($data == 256) {
					$data = 'Daylight';
				} elseif ($data == 512) {
					$data = 'Cloudy';
				} elseif ($data == 768) {
					$data = 'DaylightColor-fluorescence';
				} elseif ($data == 769) {
					$data = 'DaywhiteColor-fluorescence';
				} elseif ($data == 770) {
					$data = 'White-fluorescence';
				} elseif ($data == 1024) {
					$data = 'Incandenscense';
				} elseif ($data == 3840) {
					$data = 'Custom';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1003') { //Color
				if ($data == 0) {
					$data = 'Chroma Saturation Normal(STD)';
				} elseif ($data == 256) {
					$data = 'Chroma Saturation High';
				} elseif ($data == 512) {
					$data = 'Chroma Saturation Low(ORG)';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1004') { //Tone
				if ($data == 0) {
					$data = 'Contrast Normal(STD)';
				} elseif ($data == 256) {
					$data = 'Contrast High(HARD)';
				} elseif ($data == 512) {
					$data = 'Contrast Low(ORG)';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1010') { //FlashMode
				if ($data == 0) {
					$data = 'Auto';
				} elseif ($data == 1) {
					$data = 'On';
				} elseif ($data == 2) {
					$data = 'Off';
				} elseif ($data == 3) {
					$data = 'Red-Eye Reduction';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1020') { //Macro
				if ($data == 0) {
					$data = 'Off';
				} elseif ($data == 1) {
					$data = 'On';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1021') { //FocusMode
				if ($data == 0) {
					$data = 'Auto';
				} elseif ($data == 1) {
					$data = 'Manual';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1030') { //SlowSync
				if ($data == 0) {
					$data = 'Off';
				} elseif ($data == 1) {
					$data = 'On';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1031') { //PictureMode
				if ($data == 0) {
					$data = 'Auto';
				} elseif ($data == 1) {
					$data = 'Portrait';
				} elseif ($data == 2) {
					$data = 'Landscape';
				} elseif ($data == 4) {
					$data = 'Sports';
				} elseif ($data == 5) {
					$data = 'Night';
				} elseif ($data == 6)  {
					$data = 'Program AE';
				} elseif ($data == 256) {
					$data = 'Aperture Prority AE';
				} elseif ($data == 512) {
					$data = 'Shutter Prority';
				} elseif ($data == 768) {
					$data = 'Manual Exposure';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1100') { //ContinuousTakingBracket
				if ($data == 0) {
					$data = 'Off';
				} elseif ($data == 1) {
					$data = 'On';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1300') { //BlurWarning
				if ($data == 0) {
					$data = 'No Warning';
				} elseif ($data == 1) {
					$data = 'Warning';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1301') { //FocusWarning
				if ($data == 0) {
					$data = 'Auto Focus Good';
				} elseif ($data == 1) {
					$data = 'Out of Focus';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
			if ($tag=='1302') { //AEWarning
				if ($data == 0) {
					$data = 'AE Good';
				} elseif ($data == 1) {
					$data = 'Over Exposure';
				} else {
					$data = 'Unknown: '.$data;
				}
			}
		} elseif ($type=='UNDEFINED') {



		} else {
			$data = bin2hex($data);
			if ($intel==1) {
				$data = intel2Moto($data);
			}
		}

		return $data;
	}



	//=================
	// Fujifilm Special data section
	//====================================================================
	function parseFujifilm($block,&$result) {

		//if ($result['Endien']=='Intel') $intel=1;
		//else $intel=0;
		$intel=1;

		$model = $result['IFD0']['Model'];

		$place=8; //current place
		$offset=8;


		$num = bin2hex(substr($block,$place,4));
		$place+=4;
		if ($intel==1) {
			$num = intel2Moto($num);
		}
		$result['SubIFD']['MakerNote']['Offset'] = hexdec($num);

			//Get number of tags (2 bytes)
		$num = bin2hex(substr($block,$place,2));
		$place+=2;
		if ($intel==1) {
			$num = intel2Moto($num);
		}
		$result['SubIFD']['MakerNote']['MakerNoteNumTags'] = hexdec($num);

		//loop thru all tags  Each field is 12 bytes
		for ($i=0;$i<hexdec($num);$i++) {

				//2 byte tag
			$tag = bin2hex(substr($block,$place,2));
			$place+=2;
			if ($intel==1) {
				$tag = intel2Moto($tag);
			}
			$tag_name = lookup_Fujifilm_tag($tag);

				//2 byte type
			$type = bin2hex(substr($block,$place,2));
			$place+=2;
			if ($intel==1) {
				$type = intel2Moto($type);
			}
			$size = 0;
			lookup_type($type,$size);

				//4 byte count of number of data units
			$count = bin2hex(substr($block,$place,4));
			$place+=4;
			if ($intel==1) {
				$count = intel2Moto($count);
			}
			$bytesofdata = $size*hexdec($count);

				//4 byte value of data or pointer to data
			$value = substr($block,$place,4);
			$place+=4;


			if ($bytesofdata<=4) {
				$data = $value;
			} else {
				$value = bin2hex($value);
				if ($intel==1) {
					$value = intel2Moto($value);
				}
				$data = substr($block,hexdec($value)-$offset,$bytesofdata*2);
			}
			$formated_data = formatFujifilmData($type,$tag,$intel,$data);

			if ($result['VerboseOutput']==1) {
				$result['SubIFD']['MakerNote'][$tag_name] = $formated_data;
				if ($type=='URATIONAL' || $type=='SRATIONAL' || $type=='USHORT' || $type=='SSHORT' || $type=='ULONG' || $type=='SLONG' || $type=='FLOAT' || $type=='DOUBLE') {
					$data = bin2hex($data);
					if ($intel==1) {
						$data = intel2Moto($data);
					}
				}
				$result['SubIFD']['MakerNote'][$tag_name.'_Verbose']['RawData'] = $data;
				$result['SubIFD']['MakerNote'][$tag_name.'_Verbose']['Type'] = $type;
				$result['SubIFD']['MakerNote'][$tag_name.'_Verbose']['Bytes'] = $bytesofdata;
			} else {
				$result['SubIFD']['MakerNote'][$tag_name] = $formated_data;
			}
		}
	}
}
?>