<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* Get the correct path for the file filename
*
* @param $filename
* @return string
*/

function mediagallery_getpath ($filename) {

	global $opnConfig;

	$theme = $opnConfig['permission']->UserInfo ('theme');
	if ($theme == '') {
		$theme = $opnConfig['Default_Theme'];
	}
	$dir = $opnConfig['datasave']['themes_' . $theme]['path'];
	if (!file_exists ($dir . $filename) ) {
		$dir = _OPN_ROOT_PATH . 'themes/' . $theme . '/tpl/mediagallery/';
		if (!file_exists ($dir . $filename) ) {
			$dir = $opnConfig['datasave']['mediagallery_templates']['path'];
			if (!file_exists ($dir . $filename) ) {
				$dir = _OPN_ROOT_PATH . 'modules/mediagallery/templates/';
			}
		}
	}
	return $dir;

}

/**
* Get the correct url for the file filename
*
* @param $filename
* @return string
*/

function mediagallery_geturl ($filename) {

	global $opnConfig;

	$theme = $opnConfig['permission']->UserInfo ('theme');
	if ($theme == '') {
		$theme = $opnConfig['Default_Theme'];
	}
	$dir = $opnConfig['datasave']['themes_' . $theme]['path'];
	$url = $opnConfig['datasave']['themes_' . $theme]['url'];
	if (!file_exists ($dir . $filename) ) {
		$dir = _OPN_ROOT_PATH . 'themes/' . $theme . '/tpl/mediagallery/';
		$url = $opnConfig['opn_url'] . '/themes/' . $theme . '/tpl/mediagallery';
		if (!file_exists ($dir . $filename) ) {
			$dir = $opnConfig['datasave']['mediagallery_templates']['path'];
			$url = $opnConfig['datasave']['mediagallery_templates']['url'];
			if (!file_exists ($dir . $filename) ) {
				$dir = _OPN_ROOT_PATH . 'modules/mediagallery/templates/';
				$url = $opnConfig['opn_url'] . '/modules/mediagallery/templates';
			}
		}
	}
	return $url . '/' . $filename;

}

function sanitize_data(&$value, $key) {
	$t = $key;
	if (is_array($value)) {
		array_walk($value, 'sanitize_data');
	} else {
		# sanitize against sql/html injection; trim any nongraphical non-ASCII character:
		$value = trim(htmlentities(strip_tags(trim($value,"\x7f..\xff\x0..\x1f")),ENT_QUOTES));
	}
}

function cornerleft() {
	header("Content-type: image/gif");
	header("Content-length: 290");
	echo base64_decode('R0lGODlhGQAZAMQAAP///+zu8d3h5tXb4dbW1s/V3czU2sXN1c'.
		'PK0cPExMHCw7y+wLW1tbC2va6yuKurrJmZmf///wAAAAAAAAAA'.
		'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BA'.
		'UUABEALAAAAAAZABkAAAWfICCOZGmeaHoqysI8CZG4sEzHSZ6I'.
		'CeJEEULg8AsOi0IgULRACgoNIOEZDQoGyoiIAUwECkUvuBvAZk'.
		'UPI1F6ZBuyS0Ds6RxbzXCR0C4Ol+FKPAdVQmtGb4BxTVJ0jHiJ'.
		'W2R8f4mBAGmFSAGIlXFzdlOPnXpffqKjcoNunYBMTqeskRFesL'.
		'GXh6yVPKG5ugBCtb08vbYJxKjGx5ByyokhADs='.
		'');
}

function cornerright() {
	header("Content-type: image/gif");
	header("Content-length: 292");
	echo base64_decode('R0lGODlhGQAZAMQAAP///+zv8t3h5tXc5NbW1s/V3dHS08XN1c'.
		'PK0cLDw8HCw7y+wLW1ta+0u66yuKurrJmZmf///wAAAAAAAAAA'.
		'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BA'.
		'UUABEALAAAAAAZABkAAAWhYCSOZGlGCQCc7JmubSy+skzX5xAY'.
		'Km4OAsLNJyrsIo8eMaJTiBhKH9AgciyiNSM10jgMZc2qFtuaih'.
		'qF4JelPR+OSVg54Iw4jIknuWTmprdWeyNtXG9bXWsjYXZ4YjuC'.
		'fWgCh2lCe4RdR4VwZIt3AXmMoHpyTAOUk2d/Z1elAQRVb7B2sm'.
		'cILwm5CQYJDwwLu72/wb7ALyrIycrLzM3OyyEAOw=='.
		'');
}

function DeleteAlbumsForeignUser ($aid) {

	global $opnConfig, $opnTables;

	include_once (_OPN_ROOT_PATH . 'modules/mediagallery/include/class.filefunctions.php');
	$result = $opnConfig['database']->Execute ('SELECT pid, filename FROM ' . $opnTables['mediagallery_pictures'] . ' WHERE aid=' . $aid);
	$pictures =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ FileFunctions;
	while (! $result->EOF) {
		$pid = $result->fields['pid'];
		$filename = $result->fields['filename'];
		DeletePicturesForeignUser ($pid);
		$pictures->DeleteThumbnails ($pid, $filename);
		$pictures->DeleteFile ($pid, $filename);
		$pictures->DeleteFile ($pid, $filename, _PATH_TEMP);
		$result->MoveNext ();
	}
	$result->Close ();
	unset ($pictures);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mediagallery_pictures'] . ' WHERE aid=' . $aid);

}

function DeletePicturesForeignUser ($pid) {

	global $opnConfig, $opnTables;

	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mediagallery_rate'] . ' WHERE pid=' . $pid);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mediagallery_ecards'] . ' WHERE pid=' . $pid);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mediagallery_userfavs'] . ' WHERE pid=' . $pid);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mediagallery_comments'] . ' WHERE sid=' . $pid);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mediagallery_exif'] . ' WHERE pid=' . $pid);

}

?>